export class PromiseCancel {
    constructor() {
        this.raceHasBeenCalled = false;
        this.assign();
    }
    cancelResolve(value) {
        if (this.raceHasBeenCalled) {
            this.resolve(value);
            this.assign();
        }
    }
    cancelReject(reason) {
        if (this.raceHasBeenCalled) {
            this.reject(reason);
            this.assign();
        }
    }
    race(...promises) {
        this.raceHasBeenCalled = true;
        return Promise.race([this.promise, ...promises]);
    }
    assign() {
        this.promise = new Promise((resolve, reject) => {
            this.resolve = resolve;
            this.reject = reject;
        });
    }
}
