import { Rule } from '../composition/useValidation';
import { FormField } from './FormField';
declare type ValidateResult = void | string;
export declare class Form {
    private simpleMap;
    private keyedSetMap;
    private reactiveFormFieldMap;
    private trySetKeyedSet;
    private tryGetKeyedSet;
    private tryGetSimple;
    submitting: import("vue").Ref<boolean>;
    registerField(uid: number, name: string, modelValue: unknown, rules: Rule[]): FormField;
    validate(uid: number): Promise<PromiseSettledResult<ValidateResult>[]> | undefined;
    validateAll(): Promise<boolean>;
    onDelete(uid: number): void;
    getErrors(): import("vue").ComputedRef<string[]>;
    resetFields(toDefaultValues?: boolean): void;
    private getPromisesFor;
    private isEveryFormFieldTouchedWith;
    private static validateFactory;
}
export {};
